//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Locking.LockController
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Lock Server command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class LockServerRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _lockIdentifier;
        
        private Tecan.Sila2.IntegerDto _timeout;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public LockServerRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="lockIdentifier">
        ///        The lock identifier that has to be sent along with every (lock protected) request to use the server's
        ///        functionality.
        ///      </param>
        /// <param name="timeout">
        ///        The time (in seconds) after a SiLA Server is automatically unlocked when no request with a valid lock identifier
        ///        has been received meanwhile. A timeout of zero seconds specifies an infinite time (no timeout).
        ///      </param>
        public LockServerRequestDto(string lockIdentifier, long timeout, Tecan.Sila2.IBinaryStore store)
        {
            LockIdentifier = new Tecan.Sila2.StringDto(lockIdentifier, store);
            Timeout = new Tecan.Sila2.IntegerDto(timeout, store);
        }
        
        /// <summary>
        /// The lock identifier that has to be sent along with every (lock protected) request to use the server's
        /// functionality.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto LockIdentifier
        {
            get
            {
                return _lockIdentifier;
            }
            set
            {
                _lockIdentifier = value;
            }
        }
        
        /// <summary>
        /// The time (in seconds) after a SiLA Server is automatically unlocked when no request with a valid lock identifier
        /// has been received meanwhile. A timeout of zero seconds specifies an infinite time (no timeout).
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.IntegerDto Timeout
        {
            get
            {
                return _timeout;
            }
            set
            {
                _timeout = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/LockController/v1/Command/LockServer";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(LockIdentifier, "lockIdentifier");
            Argument.Validate(Timeout, "timeout");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(LockIdentifier, "lockIdentifier")) 
                        + Argument.Require(Timeout, "timeout"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Unlock Server command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class UnlockServerRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _lockIdentifier;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public UnlockServerRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="lockIdentifier">The lock identifier that has been used to lock the SiLA Server.</param>
        public UnlockServerRequestDto(string lockIdentifier, Tecan.Sila2.IBinaryStore store)
        {
            LockIdentifier = new Tecan.Sila2.StringDto(lockIdentifier, store);
        }
        
        /// <summary>
        /// The lock identifier that has been used to lock the SiLA Server.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto LockIdentifier
        {
            get
            {
                return _lockIdentifier;
            }
            set
            {
                _lockIdentifier = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/LockController/v1/Command/UnlockServer";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(LockIdentifier, "lockIdentifier");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(LockIdentifier, "lockIdentifier"));
        }
    }
}
